#include<bits/stdc++.h>

using namespace std;


int resenje[4][1000];
int broj_jedinica[1000];
string krvna_grupa[1000];

int main(){
	int n,o,a,b,ab;
	cin>>n>>o>>a>>b>>ab;
	for(int i=0;i<n;i++){
		resenje[0][i]=0;
		resenje[1][i]=0;
		resenje[2][i]=0;
		resenje[3][i]=0;
		cin>>krvna_grupa[i]>>broj_jedinica[i];
	}
	for(int i=0;i<n;i++){
		if(krvna_grupa[i]=="O"){
			resenje[1][i]=0;
			resenje[2][i]=0;
			resenje[3][i]=0;
			resenje[0][i]+=broj_jedinica[i];
			o-=broj_jedinica[i];
		}
	}
	for(int i=0;i<n;i++){
		if(krvna_grupa[i]=="A"){
			if(a>=broj_jedinica[i]){
				resenje[1][i]+=broj_jedinica[i];
				a-=broj_jedinica[i];
			}
			else{
				resenje[1][i]+=a;
				resenje[0][i]+=broj_jedinica[i]-a;
				o=o-broj_jedinica[i]+a;
				a=0;
			}
		}
	}
	for(int i=0;i<n;i++){
		if(krvna_grupa[i]=="B"){
			if(b>=broj_jedinica[i]){
				resenje[2][i]+=broj_jedinica[i];
				b-=broj_jedinica[i];
			}
			else{
				resenje[2][i]+=b;
				resenje[0][i]+=broj_jedinica[i]-b;
				o=o-broj_jedinica[i]+b;
				b=0;
			}
		}
	}
	for(int i=0;i<n;i++){
		if(krvna_grupa[i]=="AB"){
			if(o>=broj_jedinica[i]){
				resenje[0][i]+=broj_jedinica[i];
				o-=broj_jedinica[i];
			}
			else{
				if(a>=broj_jedinica[i]-o){
					resenje[0][i]+=o;
					resenje[1][i]+=broj_jedinica[i]-o;
					a=a-broj_jedinica[i]+o;
					o=o;
				}
				else{
					if(b>=broj_jedinica[i]-o-a){
						resenje[0][i]+=o;
						resenje[1][i]+=a;
						resenje[2][i]+=broj_jedinica[i]-o-a;
						b=b-broj_jedinica[i]+o+a;
						a=0;
						o=0;
					}
					resenje[0][i]+=o;
					resenje[1][i]+=a;
					resenje[2][i]+=b;
					resenje[3][i]+=broj_jedinica[i]-o-a-b;
					ab=ab-broj_jedinica[i]+o+a+b;
					o=0;
					a=0;
					b=0;
				}
			}
		}
	}
	if( o<0||a<0||b<0||ab<0){
		cout<<"nemoguce";
	}
	else{
		cout<<"moguce \n";
		for(int i=0;i<n;i++){
			cout<<resenje[0][i]<<" "<<resenje[1][i];
			cout<<" "<<resenje[2][i]<<" "<<resenje[3][i]<<"\n";
		}
	}
	return 0;
	
}